<?php
/*
Plugin Name: Stack Overflow Widget
Plugin URI: http://www.grumpydev.com/2009/01/09/stack-overflow-wordpress-widget/
Description: Display Stack Overflow Reputation 
Author: Steve Robbins
Version: 1.0.3
Author URI: http://www.grumpydev.com/
*/

function widget_sowidget_init() {

	// Check to see required Widget API functions are defined...
	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
		return; // ...and if not, exit gracefully from the script.

	// This function prints the sidebar widget--the cool stuff!
	function widget_sowidget($args) {

		// $args is an array of strings which help your widget
		// conform to the active theme: before_widget, before_title,
		// after_widget, and after_title are the array keys.
		extract($args);

		// Collect our widget's options, or define their defaults.
		$options = get_option('widget_sowidget');
		$username = empty($options['username']) ? 'username' : $options['username'];
		$email = empty($options['email']) ? 'email!' : $options['email'];
		$title = "Stack Overflow";
		$hash = md5($email);

 		// It's important to use the $before_widget, $before_title,
 		// $after_title and $after_widget variables in your output.
		echo $before_widget;
		echo $before_title . $title . $after_title;
		echo widget_sowidget_getsocontent($username, $hash);
		echo $after_widget;
	}

	function widget_sowidget_getsocontent($userid, $hash) {
		$url = "http://stackoverflow.com/users/$userid";
		$gravatar = '<img border="0" alt="Gravatar" src="http://www.gravatar.com/avatar/'.$hash.'?s=48&d=identicon&r=PG" height=48 width=48 />';

		$file = fopen ($url, "r");
		if (!$file) {
			return "";
		}
		while (!feof ($file)) {
			$raw .= fgets ($file, 1024);
		}
		fclose($file);

		$newlines = array("\t","\n","\r","\x20\x20","\0","\x0B");
		$content = str_replace($newlines, "", html_entity_decode($raw));

		$repFindStart = '<div class="summarycount">';
		$repFindEnd = '</div>';
		$repStart = strpos($content,$repFindStart) + strlen($repFindStart);
		$repEnd = strpos($content,$repFindEnd,$repStart);
		$rep = substr($content,$repStart,$repEnd-$repStart);

		$usernameFindStart = '<div id="subheader"><h1>';
		$usernameFindEnd = '</h1>';
		$usernameStart = strpos($content, $usernameFindStart) + strlen($usernameFindStart);
		$usernameEnd = strpos($content, $usernameFindEnd, $usernameStart);
		$username = substr($content, $usernameStart, $usernameEnd-$usernameStart);

		$gravatar = str_replace("[HASH]", $hash, $gravatar);

		$badgesFindStart = '<a name="badges">';
		$badgesFindMid = '<h1>Badges</h1>';
		$badgesFindEnd = '</div>';
		$badgesStart = strpos($content, $badgesFindStart) + strlen($badgesFindStart);
		$badgesStart = strpos($content, $badgesFindMid, $badgesStart) + strlen($badgesFindMid);
		$badgesEnd = strpos($content, $badgesFindEnd, $badgesStart);
		$badges = substr($content, $badgesStart, $badgesEnd-$badgesStart);

		// Calculate multiple badges
		$gold = 0;
		$silver = 0;
		$bronze = 0;

		$findGold = 'class="badge1"';
		$findSilver = 'class="badge2"';
		$findBronze = 'class="badge3"';	
		$findMultiplier = '<span class="item-multiplier">';
		$findMultiplierEnd = '</span>';		

		$findIndex = 0;
		while (strpos($badges, $findGold,  $findIndex) != 0)
		{
                        $findIndex = strpos($badges, $findGold, $findIndex) + strlen($findGold);
 
		        $badgeEnd = strpos($badges, '<br', $findIndex);
                        $badge = substr($badges, $findIndex, $badgeEnd-$findIndex);
                        if (substr_count($badge, $findMultiplier) == 0) {
                                $gold++;
                        } else {
                                $valueStart = strpos($badge, $findMultiplier) + strlen($findMultiplier);
                                $valueEnd = strpos($badge, $findMultiplierEnd, $valueStart);
                                $value = intval(preg_replace ('/[^\d\s]/', '', substr($badge, $valueStart, $valueEnd-$valueStart)));
                                if ($value == 0)
                                        $value = 1;

                                $gold += $value;
                        }
		}

                $findIndex = 0;
                while (strpos($badges, $findSilver, $findIndex) != 0)
                {
                        $findIndex = strpos($badges, $findSilver, $findIndex) + strlen($findSilver);
 
                        $badgeEnd = strpos($badges, '<br', $findIndex);
                        $badge = substr($badges, $findIndex, $badgeEnd-$findIndex);
                        if (substr_count($badge, $findMultiplier) == 0) {
                                $silver++;
                        } else {
                                $valueStart = strpos($badge, $findMultiplier) + strlen($findMultiplier);
                                $valueEnd = strpos($badge, $findMultiplierEnd, $valueStart);
                                $value = intval(preg_replace ('/[^\d\s]/', '', substr($badge, $valueStart, $valueEnd-$valueStart)));
                                if ($value == 0)
                                        $value = 1;

                                $silver += $value;
                        }
		}

                $findIndex = 0;
                while (strpos($badges, $findBronze, $findIndex) != 0)
                {
                        $findIndex = strpos($badges, $findBronze, $findIndex) + strlen($findBronze);

                        $badgeEnd = strpos($badges, '<br', $findIndex);
                        $badge = substr($badges, $findIndex, $badgeEnd-$findIndex);
                        if (substr_count($badge, $findMultiplier) == 0) {
                                $bronze++;
                        } else {
                                $valueStart = strpos($badge, $findMultiplier) + strlen($findMultiplier);
                                $valueEnd = strpos($badge, $findMultiplierEnd, $valueStart);
                                $value = intval(preg_replace ('/[^\d\s]/', '', substr($badge, $valueStart, $valueEnd-$valueStart)));
                                if ($value == 0)
                                        $value = 1;

                                $bronze += $value;
                        }
                }

		$content='<div style="background-color: #dddddd; border: 1px solid #888888; display: block; float: left; padding: 2px; margin: 2px;width: auto; line-height: 1.3em !important;"';
                $content.='<div style="float: left; width: 48px; display: block; vertical-align: middle;">';
                $content.='<a href="'.$url.'" target="_blank">';
		$content.=$gravatar;
                $content.='</a>';
                $content.='</div>';
                $content.='<div style="float: right; width: 100px; text-align: right; display: block;">';
                $content.='<a href="'.$url.'" target="_blank">'.htmlentities($username).'</a><br />';
                $content.='<span style="font-size: 12px;">'.$rep.'</span><span style="color: #A00004;">r</span>';
		$content.='<br/>';
		if ($gold > 0)
			$content.=$gold.'<span style="color: #ffcc00; vertical-align:baseline;">&#9679;</span> ';
		if ($silver > 0)
			$content.=$silver.'<span style="color: #c0c0c0; vertical-align:baseline;">&#9679;</span> ';
		if ($bronze > 0)
			$content.=$bronze.'<span style="color: #cc9966; vertical-align:baseline;">&#9679;</span> ';

		
		$content.='</div>'; 
            	$content.='</div>';
              $content.='<div style="clear: both;"></div>';

		return $content;
	}

	function widget_sowidget_control() {
		$options = get_option('widget_sowidget');
		if ( $_POST['sowidget-submit'] ) {
			$options['username'] = strip_tags(stripslashes($_POST['sowidget-username']));
			$options['email'] = strip_tags(stripslashes($_POST['sowidget-email']));
			update_option('widget_sowidget', $options);
		}

		$username = $options['username'];
		$email = $options['email'];
?>
		<div>
		<label for="sowidget-username" style="line-height:35px;display:block;">Stack Overflow User Number:<br/><input type="text" id="sowidget-username" name="sowidget-username" value="<?php echo $username; ?>" /></label>
		<label for="sowidget-email" style="line-height:35px;display:block;">Email:<br/><input type="text" id="sowidget-email" name="sowidget-email" value="<?php echo $email; ?>" /></label>
		<input type="hidden" name="sowidget-submit" id="sowidget-submit" value="1" />
		</div>
	<?php
	// end of widget_sowidget_control()
	}

	// This registers the widget. About time.
	register_sidebar_widget('Stack Overflow Widget', 'widget_sowidget');

	// This registers the (optional!) widget control form.
	register_widget_control('Stack Overflow Widget', 'widget_sowidget_control');
}

// Delays plugin execution until Dynamic Sidebar has loaded first.
add_action('plugins_loaded', 'widget_sowidget_init');
?>
